moItems = {};
source(MultiOverlayV3.modDir.."scripte/module/items/moItemsConfig.lua");

function moItems:update(dt)
	if moModule.active.items.isRunning then
		if moItems.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateItems"] ~= nil then return;end;
			moSetGetExtras:addTimer( {delay=moItems.values.updateTimer, name="updateItems", repeatable=1, ms=false, action=moItems.loadItems} ); 
		else
			moItems:loadItems();
		end;
	end;
end;

function moItems:loadItems()
	moItems:loadOwnItems();	
end;

local test = true;
function moItems:loadOwnItems()
	local playerFarmId = g_currentMission.player.farmId;	
	moItems.values.items = {pallets={}, other={}}; --new
	function getMapItems()		
		for key, value in pairs (g_currentMission.ownedItems) do
			if key ~= nil and value ~= nil and value.items ~= nil and type(value.items) == "table" then			
				for _, item in pairs(value.items) do				
					if item ~= nil and type(item) == "table" and item.typeName ~= nil and (string.find(item.typeName:lower(), "pallet")) then						
						if item.spec_fillUnit ~= nil and item.spec_fillUnit.fillUnits ~= nil and item.spec_fillUnit.fillUnits[1] ~= nil and item.spec_fillUnit.fillUnits[1].fillType ~= nil then
							local fillType = item.spec_fillUnit.fillUnits[1].fillType;						
							--if item.spec_fillUnit.fillUnits[1].fillLevel == item.spec_fillUnit.fillUnits[1].capacity then
								local x0,y0,z0 = getWorldTranslation(item.rootNode);
								if moItems.values.items.pallets[fillType] == nil then moItems.values.items.pallets[fillType] = {};end;
								moItems.values.items.pallets[fillType][#moItems.values.items.pallets[fillType]+1] = {typeName=item.typeName,fillLevel=item.spec_fillUnit.fillUnits[1].fillLevel,capacity=item.spec_fillUnit.fillUnits[1].capacity,x=x0,y=y0,z=z0};							
							--end;
						end;
					elseif item ~= nil and type(item) == "table" and item.typeName ~= nil then
						--if item.spec_fillUnit ~= nil and item.spec_fillUnit.fillUnits ~= nil and item.spec_fillUnit.fillUnits[1] ~= nil and item.spec_fillUnit.fillUnits[1].fillType ~= nil then
						--	local fillType = item.spec_fillUnit.fillUnits[1].fillType;						
							--if item.spec_fillUnit.fillUnits[1].fillLevel == item.spec_fillUnit.fillUnits[1].capacity then
								--local x0,y0,z0 = getWorldTranslation(item.rootNode);
								--if moItems.values.items.other[fillType] == nil then moItems.values.items.other[fillType] = {};end;
								--moItems.values.items.other[fillType][#moItems.values.items.other[fillType]+1] = {typeName=item.typeName, fillLevel=item.spec_fillUnit.fillUnits[1].fillLevel,capacity=item.spec_fillUnit.fillUnits[1].capacity,x=x0,y=y0,z=z0};							
							--end;
						--end;											
					end;
				end;
			end;
		end;		
	end;
	--doFillUtilItemsToServer
	getMapItems();
	if test then 		
		--print(DebugUtil.printTableRecursively(moItems.values.items, "items ", 0, 3));
		--print(DebugUtil.printTableRecursively(doFillUtilItemsToServer, "doFillUtilItemsToServer ", 0, 5))
		test=false;
	end;	
end;

function moItems:getOwnItemsPal(fillType, objectArea, distance)
	if fillType == nil or moFillTypes.values.fillTypes[fillType] == nil or moItems.values.items == nil or moItems.values.items["pallets"] == nil then return nil;end;
	local playerFarmId = g_currentMission.player.farmId;
	local defaultDistance = distance or 5;
	local palFull = 0;
	local palNotFull = 0;
	if moItems.values.items["pallets"][fillType] == nil then return nil;end;
	if objectArea == nil then			
		for _, index in pairs (moItems.values.items["pallets"][fillType]) do					
			if index.fillLevel == index.capacity then
				palFull = palFull+1;
			elseif index.fillLevel > 0.0 and index.fillLevel < index.capacity then
				palNotFull = palNotFull+1;
			end;				
		end;			
	else	
		if objectArea.palletSpawnerNode == nil then return nil;end;
		local x, y, z = localToWorld(objectArea.palletSpawnerNode, 0.5 * objectArea.palletSpawnerAreaSizeX, 0, 0.5 * objectArea.palletSpawnerAreaSizeZ); --getWorldTranslation(palletsModule.palletSpawnerNode);
		if x == nil then return nil;end;		
		
			for _, index in pairs (moItems.values.items["pallets"][fillType]) do			
				if index.x ~= nil and index.y ~= nil and index.z ~= nil then				
					local mathDistance = MathUtil.vector3Length(index.x-x, index.y-y, index.z-z);
					if mathDistance < defaultDistance then 
						if index.fillLevel == index.capacity then
							palFull = palFull+1;
						elseif index.fillLevel > 0.0 and index.fillLevel < index.capacity then
							palNotFull = palNotFull+1;
						end;
					end;
				end;
			end;
		
	end;
	return palFull, palNotFull;	
end;
